"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dropFirstBy = void 0;
const _heap_1 = require("./_heap");
const _purryOrderRules_1 = require("./_purryOrderRules");
function dropFirstBy(...args) {
    return (0, _purryOrderRules_1.purryOrderRulesWithArgument)(dropFirstByImplementation, args);
}
exports.dropFirstBy = dropFirstBy;
function dropFirstByImplementation(data, compareFn, n) {
    if (n >= data.length) {
        return [];
    }
    if (n <= 0) {
        return data.slice();
    }
    const heap = data.slice(0, n);
    (0, _heap_1.heapify)(heap, compareFn);
    const out = [];
    const rest = data.slice(n);
    for (const item of rest) {
        const previousHead = (0, _heap_1.heapMaybeInsert)(heap, compareFn, item);
        out.push(previousHead ?? item);
    }
    return out;
}
