"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatMap = void 0;
const flatten_1 = require("./flatten");
const purry_1 = require("./purry");
function flatMap(...args) {
    return (0, purry_1.purry)(flatMapImplementation, args, lazyImplementation);
}
exports.flatMap = flatMap;
function flatMapImplementation(data, callbackfn) {
    return (0, flatten_1.flatten)(data.map(callbackfn));
}
const lazyImplementation = (callbackfn) => (value, index, data) => {
    const next = callbackfn(value, index, data);
    return Array.isArray(next)
        ? { done: false, hasNext: true, hasMany: true, next }
        : { done: false, hasNext: true, next };
};
