"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.intersectionWith = void 0;
const _reduceLazy_1 = require("./_reduceLazy");
const purry_1 = require("./purry");
function intersectionWith(...args) {
    return (0, purry_1.purry)(intersectionWithImplementation, args, lazyImplementation);
}
exports.intersectionWith = intersectionWith;
const intersectionWithImplementation = (array, other, comparator) => (0, _reduceLazy_1._reduceLazy)(array, lazyImplementation(other, comparator));
const lazyImplementation = (other, comparator) => (value) => other.some((otherValue) => comparator(value, otherValue))
    ? { done: false, hasNext: true, next: value }
    : { done: false, hasNext: false };
