"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeDeep = void 0;
const purry_1 = require("./purry");
function mergeDeep(...args) {
    return (0, purry_1.purry)(mergeDeepImplementation, args);
}
exports.mergeDeep = mergeDeep;
function mergeDeepImplementation(destination, source) {
    const output = { ...destination, ...source };
    for (const key in source) {
        if (!(key in destination)) {
            continue;
        }
        const { [key]: destinationValue } = destination;
        if (!isRecord(destinationValue)) {
            continue;
        }
        const { [key]: sourceValue } = source;
        if (!isRecord(sourceValue)) {
            continue;
        }
        output[key] = mergeDeepImplementation(destinationValue, sourceValue);
    }
    return output;
}
function isRecord(object) {
    return (typeof object === "object" &&
        object !== null &&
        Object.getPrototypeOf(object) === Object.prototype);
}
