"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.omit = void 0;
const fromEntries_1 = require("./fromEntries");
const hasAtLeast_1 = require("./hasAtLeast");
const purry_1 = require("./purry");
function omit(...args) {
    return (0, purry_1.purry)(_omit, args);
}
exports.omit = omit;
function _omit(data, propNames) {
    if (!(0, hasAtLeast_1.hasAtLeast)(propNames, 1)) {
        return { ...data };
    }
    if (!(0, hasAtLeast_1.hasAtLeast)(propNames, 2)) {
        const [propName] = propNames;
        const { [propName]: omitted, ...remaining } = data;
        return remaining;
    }
    if (!propNames.some((propName) => propName in data)) {
        return { ...data };
    }
    const asSet = new Set(propNames);
    return (0, fromEntries_1.fromEntries)(Object.entries(data).filter(([key]) => !asSet.has(key)));
}
