"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._setPath = exports.setPath = void 0;
const purry_1 = require("./purry");
function setPath(...args) {
    return (0, purry_1.purry)(_setPath, args);
}
exports.setPath = setPath;
function _setPath(data, path, value) {
    const [current, ...rest] = path;
    if (current === undefined) {
        return value;
    }
    if (Array.isArray(data)) {
        return data.map((item, index) => index === current ? _setPath(item, rest, value) : item);
    }
    if (data === null || data === undefined) {
        throw new Error("Path doesn't exist in object!");
    }
    return {
        ...data,
        [current]: _setPath(data[current], rest, value),
    };
}
exports._setPath = _setPath;
