"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unique = void 0;
const _reduceLazy_1 = require("./_reduceLazy");
const purry_1 = require("./purry");
function unique(...args) {
    return (0, purry_1.purry)(uniqueImplementation, args, lazyImplementation);
}
exports.unique = unique;
const uniqueImplementation = (array) => (0, _reduceLazy_1._reduceLazy)(array, lazyImplementation());
function lazyImplementation() {
    const set = new Set();
    return (value) => {
        if (set.has(value)) {
            return { done: false, hasNext: false };
        }
        set.add(value);
        return { done: false, hasNext: true, next: value };
    };
}
