"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uniqueBy = void 0;
const _reduceLazy_1 = require("./_reduceLazy");
const purry_1 = require("./purry");
function uniqueBy(...args) {
    return (0, purry_1.purry)(uniqueByImplementation, args, lazyImplementation);
}
exports.uniqueBy = uniqueBy;
const uniqueByImplementation = (data, keyFunction) => (0, _reduceLazy_1._reduceLazy)(data, lazyImplementation(keyFunction));
function lazyImplementation(keyFunction) {
    const set = new Set();
    return (value, index, data) => {
        const key = keyFunction(value, index, data);
        if (set.has(key)) {
            return { done: false, hasNext: false };
        }
        set.add(key);
        return { done: false, hasNext: true, next: value };
    };
}
