import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function differenceWith(...args) {
    return purry(differenceWithImplementation, args, lazyImplementation);
}
function differenceWithImplementation(array, other, isEquals) {
    return _reduceLazy(array, lazyImplementation(other, isEquals));
}
const lazyImplementation = (other, isEquals) => (value) => other.every((otherValue) => !isEquals(value, otherValue))
    ? { done: false, hasNext: true, next: value }
    : { done: false, hasNext: false };
