import { entries } from "./entries";
import { purry } from "./purry";
export function evolve(...args) {
    return purry(_evolve, args);
}
function _evolve(data, evolver) {
    if (typeof data !== "object" || data === null) {
        return data;
    }
    const out = { ...data };
    for (const [key, value] of entries(evolver)) {
        if (key in out) {
            out[key] =
                typeof value === "function"
                    ? value(out[key])
                    : _evolve(out[key], value);
        }
    }
    return out;
}
