import { flatten } from "./flatten";
import { purry } from "./purry";
export function flatMap(...args) {
    return purry(flatMapImplementation, args, lazyImplementation);
}
function flatMapImplementation(data, callbackfn) {
    return flatten(data.map(callbackfn));
}
const lazyImplementation = (callbackfn) => (value, index, data) => {
    const next = callbackfn(value, index, data);
    return Array.isArray(next)
        ? { done: false, hasNext: true, hasMany: true, next }
        : { done: false, hasNext: true, next };
};
