import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function flattenDeep(...args) {
    return purry(flattenDeepImplementation, args, lazyImplementation);
}
const flattenDeepImplementation = (items) => _reduceLazy(items, lazyImplementation());
const lazyImplementation = () => (value) => {
    const next = _flattenDeepValue(value);
    return Array.isArray(next)
        ? { done: false, hasNext: true, hasMany: true, next }
        : { done: false, hasNext: true, next };
};
function _flattenDeepValue(value) {
    if (!Array.isArray(value)) {
        return value;
    }
    const ret = [];
    for (const item of value) {
        if (Array.isArray(item)) {
            ret.push(...flattenDeep(item));
        }
        else {
            ret.push(item);
        }
    }
    return ret;
}
