import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function intersectionWith(...args) {
    return purry(intersectionWithImplementation, args, lazyImplementation);
}
const intersectionWithImplementation = (array, other, comparator) => _reduceLazy(array, lazyImplementation(other, comparator));
const lazyImplementation = (other, comparator) => (value) => other.some((otherValue) => comparator(value, otherValue))
    ? { done: false, hasNext: true, next: value }
    : { done: false, hasNext: false };
