import { purry } from "./purry";
export function mergeDeep(...args) {
    return purry(mergeDeepImplementation, args);
}
function mergeDeepImplementation(destination, source) {
    const output = { ...destination, ...source };
    for (const key in source) {
        if (!(key in destination)) {
            continue;
        }
        const { [key]: destinationValue } = destination;
        if (!isRecord(destinationValue)) {
            continue;
        }
        const { [key]: sourceValue } = source;
        if (!isRecord(sourceValue)) {
            continue;
        }
        output[key] = mergeDeepImplementation(destinationValue, sourceValue);
    }
    return output;
}
function isRecord(object) {
    return (typeof object === "object" &&
        object !== null &&
        Object.getPrototypeOf(object) === Object.prototype);
}
