import { fromEntries } from "./fromEntries";
import { hasAtLeast } from "./hasAtLeast";
import { purry } from "./purry";
export function omit(...args) {
    return purry(_omit, args);
}
function _omit(data, propNames) {
    if (!hasAtLeast(propNames, 1)) {
        return { ...data };
    }
    if (!hasAtLeast(propNames, 2)) {
        const [propName] = propNames;
        const { [propName]: omitted, ...remaining } = data;
        return remaining;
    }
    if (!propNames.some((propName) => propName in data)) {
        return { ...data };
    }
    const asSet = new Set(propNames);
    return fromEntries(Object.entries(data).filter(([key]) => !asSet.has(key)));
}
