import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function uniqueBy(...args) {
    return purry(uniqueByImplementation, args, lazyImplementation);
}
const uniqueByImplementation = (data, keyFunction) => _reduceLazy(data, lazyImplementation(keyFunction));
function lazyImplementation(keyFunction) {
    const set = new Set();
    return (value, index, data) => {
        const key = keyFunction(value, index, data);
        if (set.has(key)) {
            return { done: false, hasNext: false };
        }
        set.add(key);
        return { done: false, hasNext: true, next: value };
    };
}
